package xmljson.json.creating;

import com.google.gson.stream.*;

import java.io.*;

import xmljson.model.*;

public class JsonStreamOutputExample {

	public static void run() throws Exception {

		Catalog catalog = new Catalog();
		
		catalog.add(new CD("Hide your heart", "Bonnie Tyler", "UK",
				"CBS Records", 9.90f, 1988));
		catalog.add(new CD("Greatest Hits", "Dolly Parton", "USA",
				"RCA", 9.90f, 1982));
		catalog.add(new CD("Still got the blues", "Gary Moore", "UK",
                "Virgin records", 10.20f, 1990));

		StringWriter sw = new StringWriter();
		JsonWriter jsonWriter = new JsonWriter(sw);
		jsonWriter.setIndent("   ");

		saveCatalog(catalog, jsonWriter);

		jsonWriter.flush();
		
		System.out.println(sw.toString());
	}
	
	private static void saveCatalog(Catalog catalog, JsonWriter jsonWriter) 
		throws Exception {

		jsonWriter.beginObject();
		jsonWriter.name("CATALOG");

		jsonWriter.beginArray();
		for (CD cd : catalog.getItems()) {
			saveCD(cd, jsonWriter);
		}
		jsonWriter.endArray();

		jsonWriter.endObject();
	}
	
	private static void saveCD(CD cd, JsonWriter jsonWriter) throws Exception {

		jsonWriter.beginObject();
		jsonWriter.name("CD");

		jsonWriter.beginObject();
		jsonWriter.name("TITLE");
		jsonWriter.value(cd.getTitle());
		jsonWriter.name("ARTIST");
		jsonWriter.value(cd.getArtist());
		jsonWriter.name("COUNTRY");
		jsonWriter.value(cd.getCountry());
		jsonWriter.name("COMPANY");
		jsonWriter.value(cd.getCompany());
		jsonWriter.name("PRICE");
		jsonWriter.value(cd.getPrice());
		jsonWriter.name("YEAR");
		jsonWriter.value(cd.getYear());
		jsonWriter.endObject();

		jsonWriter.endObject();
	}

}
