package xmljson.json.creating;

import com.google.gson.*;

import java.io.*;

import xmljson.model.*;

public class JsonTreeOutputExample {

	public static void run() throws Exception {

		Catalog catalog = new Catalog();

		catalog.add(new CD("Hide your heart", "Bonnie Tyler", "UK",
							"CBS Records", 9.90f, 1988));
		catalog.add(new CD("Greatest Hits", "Dolly Parton", "USA",
							"RCA", 9.90f, 1982));
		catalog.add(new CD("Still got the blues", "Gary Moore", "UK",
							"Virgin records", 10.20f, 1990));

		JsonObject catalogObj = buildCatalog(catalog);

		Gson gson = new GsonBuilder().setPrettyPrinting().create();
		
		String jsonStr = gson.toJson(catalogObj);
		
		System.out.println(jsonStr);
	}
	
	private static JsonObject buildCatalog(Catalog catalog) throws Exception {

		JsonArray cdArr = new JsonArray();
		for (CD cd : catalog.getItems()) {
			cdArr.add(buildCD(cd));
		}

		JsonObject catalogObj = new JsonObject();
		catalogObj.add("CATALOG", cdArr);

		return catalogObj;
	}
	
	private static JsonObject buildCD(CD cd) throws Exception {

		JsonObject cdObj = new JsonObject();

		cdObj.addProperty("TITLE", cd.getTitle());
		cdObj.addProperty("ARTIST", cd.getArtist());
		cdObj.addProperty("COUNTRY", cd.getCountry());
		cdObj.addProperty("COMPANY", cd.getCompany());
		cdObj.addProperty("PRICE", cd.getPrice());
		cdObj.addProperty("YEAR", cd.getYear());

		return cdObj;
	}

}
