package xmljson.json.parsing;

import com.google.gson.*;

import java.io.*;

public class JsonTreeInputExample {

	public static void run(File file) throws Exception {
		
		// Use JSON tree parser to find list of CD titles and artists

		try (FileReader fileReader = new FileReader(file)) {
			
			JsonParser jsonParser = new JsonParser();
				
			JsonObject rootObj = (JsonObject)jsonParser.parse(fileReader);
			
			JsonArray cdArr = (JsonArray)rootObj.get("CATALOG");
			for (int i = 0; i < cdArr.size(); ++i) {

				JsonObject elemObj = (JsonObject)cdArr.get(i);
				JsonObject cdObj = (JsonObject)elemObj.get("CD");

				JsonPrimitive titleNode = (JsonPrimitive)cdObj.get("TITLE");
				JsonPrimitive artistNode = (JsonPrimitive)cdObj.get("ARTIST");

				System.out.println(titleNode.getAsString() + ", " + 
									artistNode.getAsString());
			}		
		}
	}
	
}
